import QtQuick 1.0
import "kanjiBlocks.js" as Logic

Rectangle{
    property ListModel highScoreModel
    property int fontSize:12
    id:highscoreBox
    visible:false
    border.color: "#008800"
    border.width: 2;
    anchors.fill: parent
    radius:20
    z:23
    anchors.leftMargin: 20
    anchors.rightMargin: 20
    anchors.topMargin: 20
    anchors.bottomMargin: 20+toolbar.height
    gradient: Gradient{
        GradientStop{position:0.0;color:"oldlace";}
        GradientStop{position:1.0;color:"moccasin";}
    }

    Image{
        id:highscoreImg
        source:"medal.png"
        anchors.fill: parent;
        anchors.bottomMargin:  (screen.height>screen.width)?20:10;
        anchors.topMargin:(screen.height>screen.width)?parent.height*0.65:closeButtonSize+10;
        anchors.rightMargin:(screen.height>screen.width)?parent.width*0.25:10;
        anchors.leftMargin:(screen.height>screen.width)?parent.width*0.25:parent.width*0.7;
    }

    Component {
        id: highscoreDelegate
        Rectangle {
            border.color: "gray";
            border.width: 3;
            height:(screen.height>screen.width)?highScoreListView.height*0.09:highScoreListView.height*0.125;
            width: highScoreListView.width;
            Rectangle{
                y:2;
                Text {
                    text: (index+1)+".";
                    x:highScoreListView.width*0.06
                    font.pixelSize: fontSize
                }
                Text {
                    text: name
                    x:highScoreListView.width*0.15
                    font.pixelSize: fontSize
                }
                Text {
                    text: time
                    x:highScoreListView.width*0.55
                    font.pixelSize: fontSize
                }
                Text {
                    text: moves
                    x:highScoreListView.width*0.75
                    font.pixelSize: fontSize
                }
            }
        }
    }


    Component {
        id: highscoreHeader
        Rectangle {
            border.color: "gray";
            border.width: 3;
            color:"lightsteelblue"
            height:highScoreListView.height*0.1
            width: highScoreListView.width;
            Text {
                text: "No.";
                x:highScoreListView.width*0.02
                font.pixelSize: fontSize
            }
            Text {
                text: "Name"
                x:highScoreListView.width*0.15
                font.pixelSize: fontSize
            }
            Text {
                text: "Time"
                x:highScoreListView.width*0.55
                font.pixelSize: fontSize
            }
            Text {
                text: "Moves"
                x:highScoreListView.width*0.75
                font.pixelSize: fontSize
            }
        }
    }

    ListView {
        id:highScoreListView
        spacing: 0;
        anchors.fill: parent
        anchors.topMargin: parent.height*0.2
        anchors.leftMargin: parent.width*0.1
        anchors.rightMargin: (screen.height>screen.width)?parent.width*0.1:parent.width*0.3;
        model: highScoreModel
        delegate:highscoreDelegate
        header:highscoreHeader
        interactive: false
    }

    Text {
        id: highscoreTxt
        anchors.fill: parent
        anchors.margins: 20
        font.pixelSize: (screen.height>screen.width)?parent.width/20:parent.height/20;
        wrapMode:Text.WordWrap;
        text: qsTr("<h1>Highscores</h1>");
        opacity: 1
    }

    CloseButton{
        id:hideHighscore
        size: closeButtonSize;
        onClicked: Logic.hideHighscoreAction();
    }
}
