import QtQuick 1.0

Rectangle {
    id: container

    property string text: "Button"
    property string colorb: "#808080"
    property string colorbLighter: "#bbbbbb"
    property string colorbDarker: "#666666"
    property string colorbText:"black"

    signal clicked

    width: buttonLabel.width + 20; height: buttonLabel.height + 8
    smooth: true
    border { width: 1; color: Qt.darker(container.colorb) }
    radius: 8
    color:container.colorb

    gradient: Gradient {
        GradientStop {
            position: 0.0
            color: {
                if (mouseArea.pressed)
                    return container.colorbDarker
                else
                    return container.colorbLighter

            }
        }
        GradientStop { position: 1.0; color: container.colorb }
    }

    MouseArea { id: mouseArea; anchors.fill: parent; onClicked: container.clicked() }

    Text {
        id: buttonLabel;
        text: container.text;
        anchors.centerIn: container;
        color: container.colorbText;
        font.pixelSize: 18
    }
}
