import QtQuick 1.0

// *****************Start Pause Box ************************
    //modified paused
    Rectangle{
        id:pauseBox
        property Item toolbar0
        property string text: "Pause Text"
        property int fontSize:12
        property int closeButtonSize: 40
        visible:false
        border.color: "#008800"
        border.width: 2;
        anchors.fill: parent
        radius:20
        anchors.leftMargin: 20
        anchors.rightMargin: {
            if (parent.height<parent.width) 20+toolbar0.width;
            else 20;
        }
        anchors.topMargin: 20
        anchors.bottomMargin: {
            if (parent.height<parent.width) 20;
            else 20+toolbar0.height;
        }
        z:22
        gradient: Gradient{
            GradientStop{position:0.0;color:"oldlace";}
            GradientStop{position:1.0;color:"moccasin";}
        }

        signal hideFunction;
        Image{
            id:pauseImage
            anchors.verticalCenter: parent.verticalCenter
            anchors.verticalCenterOffset:{if (parent.height<parent.width) 0;else -parent.width/3;}
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.horizontalCenterOffset:{if (parent.height<parent.width) -(pauseBox.width-toolbar0.width)/3.1;else 0;}
            source:"coffee.png"
            width:{
                if (screen.width>screen.height){
                    if (screen.height/screen.width>0.65){
                        ((parent.width>parent.height)?parent.height:parent.width)*0.5;
                    }
                    else{
                        ((parent.width>parent.height)?parent.height:parent.width)*0.7;
                    }
                }
                else
                {
                    ((parent.width>parent.height)?parent.height:parent.width)*0.7;
                }
            }
            height: ((parent.width>parent.height)?parent.height:parent.width)*0.7;
        }

        Text {
            id: pauseTxt
            anchors.fill: parent
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            anchors.leftMargin:{if (parent.height<parent.width) pauseImage.width+50; else pauseBox.width/5;}
            anchors.topMargin:{if (parent.height<parent.width) 0; else pauseImage.height+50;}
            font.pixelSize:{
                if (screen.width>screen.height){
                    if (screen.height/screen.width>0.65) fontSize*0.9;else fontSize;
                }
                else
                {
                    if (screen.width/screen.height>0.65) fontSize*0.9;else fontSize;
                }
            }
            text:qsTr(pauseBox.text);
        }


        OkButton{
            id:hidePauseButton
            size: closeButtonSize;
            onClicked:hideFunction();
        }
    }
    //end modified paused
//******************** End Pause Box *********************
