import QtQuick 1.0

Rectangle {
    anchors.fill: parent
    property bool adsOn: (_adsEnabled=="true");
    property bool checkIC: (_checkIC=="true")
    property bool icReq: (_ICReq=="true")
    property bool appHasFocus: (_appFocus!="undefined")?(_appFocus==true):(Qt.application.active);
    property bool internetOn: false
    property int timeLeft: 0
    property int appTime: 0
    property int numberOfRequests: 0
    property int interstitialTimeout: 0
    property int fontSize: (width+height)/50;
    property int icCheckStartTime: 0
    color:"transparent"
    z:9998

    onAppHasFocusChanged: {
        console.debug("App Has Focus: "+appHasFocus)
    }

    onNumberOfRequestsChanged: {
        console.debug("Number of requests : "+numberOfRequests+" .");
    }

    Component.onCompleted: {
        if(checkIC==true){
            isInternetConnectionOn("initialCheck");
        }
        console.debug(new Date());
    }

    InnerActiveAdInterstitial {
        id: interstitial
        appid:  _appID
        skipIn: _skipIn
        visible:false
    }

    function enableQuitAfterAd() {
        //        console.debug(_adsEnabled);console.debug(_adsEnabled=="true");console.debug(timeLeft);
        interstitial.quitAfter=true;
    }

    function showInterstitial() {
        //        console.debug(_adsEnabled);console.debug(_adsEnabled=="true");console.debug(timeLeft);
        if(interstitial.quitAfter==true && adsOn==true ){
            interstitial.loadAd();
            interstitialTimeout=appTime;
            return;
        }
        else{
            if(interstitial.quitAfter==true){
                Qt.quit();
            }
        }

        if(timeLeft>_interstitialAdInterval && adsOn==true && appHasFocus==true)
        {
            timeLeft=0;
            interstitial.loadAd();
            interstitialTimeout=appTime;
        }
    }

    function isInternetConnectionOn(appPhase){
        if(_appManager.isOnline()==false){
            _appManager.initConnection();
        }
        if(_appManager.isOnline()==true){
            internetOn=true;
            return;
        }

        icCheckStartTime=appTime;
        console.debug("iccheck "+icCheckStartTime);

        var testResponse = new XMLHttpRequest();
        console.log("requesting: " + "http://m2m1.inner-active.com/simpleM2M/clientRequestAd");
        //        adResponse.open("GET", "http://m2m1.inner-active.com/simpleM2M/clientRequestAd");
        testResponse.timeout=3000;
        testResponse.open("GET", "http://m2m1.inner-active.com/simpleM2M/clientRequestAd");
        testResponse.setRequestHeader("User-Agent",_userAgentString);
        testResponse.send();
        console.debug("Testing for Internet");

        testResponse.onreadystatechange = function() {
                    console.log("Seeking");
                    if(testResponse.readyState == XMLHttpRequest.HEADERS_RECEIVED ) {
                        if( _appManager.isOnline()==false )
                        {
                            internetOn=false;
                            console.log("NO INTERNET");
                        }
                        else
                        {
                            internetOn=true;
                            console.log("INTERNET ON");
                        }
                        if(appPhase=="initialCheck"){
                            if(internetOn==true){
                                console.debug("Not Forcing connection");
                                intro.forceConnection=false;
                            }
                            else
                            {
                                if(icReq==true){
                                    console.debug("Forcing connection");
                                    intro.forceConnection=true;
                                    intro.loading=false;
                                }
                            }
                        }
                        if(appPhase=="finalCheck"){
                            if(internetOn==true){
                                console.debug("IC found");
                                intro.forceConnection=false;
                                intro.loading=true;
                            }
                            else
                            {
                                console.debug("no IC found");
                                intro.onNoICFound();
                            }
                        }
                    }
                }
    }

    Timer {
        interval: 1000; running: true; repeat: true
        onTriggered: { timeLeft=timeLeft+1;}
    }
    Timer {
        id: appTimer
        interval: 100; running: true; repeat: true
        onTriggered: {
            appTime=appTime+1;
            if(intro!=null){
                if(icReq==true){
                    if(internetOn==true){
                        if(appTime>_introTimeOut*10){
                            intro.visible=false;
                            intro.destroy();
                        }
                    }
                }
                else
                {
                    if(appTime>_introTimeOut*10){
                        intro.visible=false;
                        intro.destroy();
                    }
                }
                if( appTime==(icCheckStartTime+60))
                {
                    if(internetOn!=true){
                        internetOn=false;
                        if(icReq==true){
                            console.debug("Forcing connection");
                            intro.forceConnection=true;
                            intro.loading=false;
                        }
                    }
                }
            }

            if( appTime==(interstitialTimeout+5)&& interstitialTimeout!=0 )
            {
                interstitial.show();
            }

            //            console.debug(appTime);
        }
    }
}
