import QtQuick 1.0

Rectangle {
    id:baseIntroWrapper
    height: 854
    width: 480

    Rectangle{

        width: (parent.height>parent.width)?360:640;
        height: (parent.height>parent.width)?640:360;
        transform: Scale { origin.x: 0; origin.y: 0; xScale: baseIntroWrapper.width/width; yScale:baseIntroWrapper.height/height}
        visible: true
        color: "#C0DEED"
        z:9999

        gradient: Gradient {
            GradientStop { position: 0.0; color: "#C0DEED" }
            GradientStop { position: 0.5; color: "azure" }
            GradientStop { position: 1.0; color: "#C0DEED" }
        }

        MouseArea{
            anchors.fill: parent
        }

        Item{
            id:mainPart
            anchors.fill: parent
            anchors.bottomMargin: (parent.height>parent.width)?parent.height*0.45:parent.height*0.1;

            Image{
                id:logo
                anchors{
                    fill: parent
                    leftMargin: (baseIntroWrapper.height>baseIntroWrapper.width)?parent.width*0.15:parent.width*0.05;
                    rightMargin: (baseIntroWrapper.height>baseIntroWrapper.width)?parent.width*0.15:parent.width*0.6;
                    topMargin: parent.height*0.05
                    bottomMargin: (baseIntroWrapper.height>baseIntroWrapper.width)?parent.height*0.25:parent.height*0.3;
                }
                fillMode:Image.Stretch
                source: "../"+_appLogo
            }
            Rectangle{
                id:content
                anchors{
                    top: (baseIntroWrapper.height>baseIntroWrapper.width)?logo.bottom:parent.top;
                    left: (baseIntroWrapper.height>baseIntroWrapper.width)?parent.left:logo.right;
                    right: parent.right
                    topMargin: 20
                }
                width: (baseIntroWrapper.height>baseIntroWrapper.width)?parent.width:parent.width/2;
                height: 150
                color:"transparent"

                Text{
                    id:appText
                    text:_appName+" "+_appVersion
                    anchors{
                        left: parent.left
                        right: parent.right
                        top: parent.top
                        topMargin: 20
                        margins: 30
                    }
                    width: parent.width
                    horizontalAlignment: Text.AlignHCenter
                    wrapMode: Text.WordWrap
                    font.bold: true
                    font.pixelSize: 28
                }
                Text{
                    id:copyright
                    text:_copyRight
                    anchors.horizontalCenter: appText.horizontalCenter
                    anchors.top: appText.bottom
                    anchors.topMargin: 8
                    verticalAlignment: Text.AlignVCenter
                    font.bold: true
                    font.pixelSize: 15
                }
                AnimatedImage{
                    id:loadingImg
                    anchors.horizontalCenter: copyright.horizontalCenter
                    anchors.top: copyright.bottom
                    anchors.topMargin: 20
                    width:150;
                    height: 40;
                    source:"loading.gif"
                }
                Text{
                    id:pleaseWait
                    text:"Please Wait ..."
                    anchors.horizontalCenter: loadingImg.horizontalCenter
                    anchors.top: loadingImg.bottom
                    anchors.topMargin: 8
                    verticalAlignment: Text.AlignVCenter
                    font.bold: true
                    font.pixelSize: 15
                }
            }
        }
    }
}
