import QtQuick 1.0

Rectangle {
    id: adContainer
    property string appid: _appID

    //these probably don't need to be specified
    property string channelid: _channelId
    property int screenWidth: adManager.width
    property int screenHeight: adManager.height
    property bool receivedAd: adManager.internetOn

    property int adWidth: 0
    property int adHeight: 0
    height: 83
    color:"transparent"

    //parent needs to set width and height so that way we can use it to request the correct sized ad

    //private properties
    //property string __adUrl: ""
    property string __clientId: ""
    property string __clickUrl:  ""
    property string __imageUrl: ""
    property string adText: ""

    signal finishedLoading()


    Text{
        id:adsText
        anchors{
            top:parent.top
            horizontalCenter:parent.horizontalCenter
        }
        font{
            pixelSize:15;
            bold: true
        }
        height: adText!=""?20:0
        width: adManager.width
        visible: receivedAd
        text: adText
        elide: Text.ElideRight
        horizontalAlignment: Text.AlignHCenter
    }
    AnimatedImage {
        id: ad
        //width: parent.width
        //height: parent.height
        z:999
        anchors{
            top:adsText.bottom
            topMargin: adText==""?15:0
            horizontalCenter: parent.horizontalCenter
            //            verticalCenter: parent.verticalCenter
        }
        width: 320;//parent.width <= sourceSize.width ? parent.width : sourceSize.width
        height: 53;//parent.height <= sourceSize.height ? parent.height : sourceSize.height
        smooth: true
        fillMode: Image.PreserveAspectFit
    }
    MouseArea {
        anchors.fill:  parent
        id: adMouse
        onClicked: { console.log("you clicked the ad"); adClicked(); }
    }

    Component.onCompleted: { init(); }


    //setup
    function init() {
        if(appid == "")
            console.log("Warning: no app id specified in inner active ad module");

    }


    //loads a new ad
    function loadAd() {
        adText="";
        receivedAd=false;
        var baseUrl = "http://m2m1.inner-active.com/simpleM2M/clientRequestAd?";

        var currentTime=new Date();

        var requestUrl = baseUrl;
        requestUrl=requestUrl+"aid=" + appid;
        requestUrl=requestUrl+"&v=Sm2m-1.5.3";
        //        requestUrl=requestUrl+"&o=true";
        requestUrl=requestUrl+ "&po=" + channelid;
        if(__clientId != "")
            requestUrl = requestUrl + "&cid=" + __clientId;
        if(_countryCode != "")
            requestUrl = requestUrl + "&l=" + _countryCode;
        if(_category != "")
            requestUrl = requestUrl + "&c=" + _category;
        if(_age != "")
            requestUrl = requestUrl + "&a=" + _age;
        if(_gender != "")
            requestUrl = requestUrl + "&g=" + _gender;
        //        requestUrl=requestUrl+"&time="+(Math.floor(currentTime/1000));
        //        requestUrl=requestUrl+"&l="+_countryCode+"&ua="+_userAgentString;
        if(screenWidth > 0 && screenHeight > 0)
            requestUrl = requestUrl + "&w=" + screenWidth + "&h=" + screenHeight;
        if(_GPSLocation != "")
            requestUrl = requestUrl + "&lg=" + _GPSLocation;

        //request ad

        var adResponse = new XMLHttpRequest();

        console.log("requesting: " + requestUrl);
        adResponse.timeout=3000;
        adResponse.open("GET", requestUrl);
        adResponse.setRequestHeader("User-Agent",_userAgentString);
        adResponse.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
        adResponse.send();

        adManager.numberOfRequests=adManager.numberOfRequests + 1;

        adResponse.onreadystatechange = function() {

                    if(adResponse.readyState == XMLHttpRequest.DONE) {
                        if(adResponse.responseXML!=null){
                            var doc = adResponse.responseXML.documentElement;
                            var haveImage = false;
                            var haveUrl = false
                            //traverse(adResponse.responseXML);
                            //                            console.log("Raspuns "+adResponse.responseText);
                            //                            console.log(new Date());
                            //process xml
                            for(var i =0; i< doc.childNodes.length; i++) {
                                //                                console.log(doc.childNodes[i].nodeName + "=" + doc.childNodes[i].nodeValue);
                                if(doc.childNodes[i].nodeName == 'Client')
                                    //assume only attribute is the client id
                                    if(__clientId==""){
                                        __clientId = doc.childNodes[i].attributes['Id'].value;
                                    }
                                if(doc.childNodes[i].nodeName == "Ad") {
                                    var adNode = doc.childNodes[i];

                                    //                                    console.log("number of ad children " + doc.childNodes[i].length);
                                    for(var x =0; x < adNode.childNodes.length; x++) {
                                        //                                        console.log(adNode.childNodes[x].nodeName + "=" + adNode.childNodes[x].nodeValue);
                                        if(adNode.childNodes[x].nodeName == 'URL') {
                                            //Click URL
                                            __clickUrl = adNode.childNodes[x].firstChild.nodeValue;
                                            console.debug("Received "+__clickUrl);
                                            haveUrl = true;
                                        }
                                        if(adNode.childNodes[x].nodeName == 'Text') {
                                            //Click URL
                                            if(adNode.childNodes[x].firstChild!=null){
                                                adText = adNode.childNodes[x].firstChild.nodeValue;
                                                console.debug("Got Text "+adText);
                                            }
                                        }

                                        if(adNode.childNodes[x].nodeName == 'Image') {
                                            //Image URL
                                            console.log("image url " + adNode.childNodes[x].firstChild.nodeValue);
                                            __imageUrl = adNode.childNodes[x].firstChild.nodeValue
                                            haveImage = true;
                                        }

                                        if(adNode.childNodes[x].nodeName == 'Text') {
                                            //Banner text
                                            //not doing text ads right now
                                        }
                                    }
                                }
                            }

                            //assign image url and click url ){// && __imageUrl!="http://cdn1.inner-active.mobi/mnt/InnerActive/Resources/USAGC/eng_pic.gif"
                            if(haveUrl && (haveImage || adText!="" ) ) {
                                ad.source = __imageUrl;
                                adWidth=320;//ad.sourceSize.width;
                                adHeight=53;//ad.sourceSize.height;
                                console.log("Size:"+adWidth+","+adHeight);
                                adContainer.finishedLoading();
                                receivedAd=true;
                            }
                            else{
                                receivedAd=false;
                            }
                        }
                        else{
                            receivedAd=false;
                        }
                    }
                    else{
                        receivedAd=false;
                    }
                }
    }




    //ad clicked launch browser
    function adClicked() {
        //will probably need custom browser launcher code because of qt bugs with launching browser
        //http://www.developer.nokia.com/Community/Wiki/How_to_launch_other_applications_in_Qt
        if(__clickUrl != "") {
            console.log("Ad clicked, launching: " + __clickUrl);
            Qt.openUrlExternally(__clickUrl);
        }
        else
            console.log("Something strange here you clicked an ad but we don't have a URL registered");

    }

}
