import QtQuick 1.0

Rectangle {
    id: adWrapper

    //specific to the timed ads
//    property int interval: 10          //reload ad every x seconds
    property bool autoStart: true       //autostart

    //aliased to the ad properties so they can be set here but reflected in the child
    //    property alias appid: ad.appid

    //these probably don't need to be specified
    property alias channelid: ad.channelid

    property alias screenWidth: ad.screenWidth
    property alias screenHeight: ad.screenHeight

    property int timePassed: 0
    property bool allowRefresh: true
    color:"transparent"
    visible:adManager.adsOn && adManager.internetOn;

    width:parent.width
    height: 83
    InnerActiveAd {
        id: ad
        anchors.centerIn: parent
        width: 320
        height: 83
        visible: ad.receivedAd
    }

    Timer {
        id: adTimer
        repeat: true
        interval: 1000

        onTriggered: {
//            console.debug("AdRotate "+timeLeft);
//            console.debug("AdRotate adsOn "+adManager.adsOn);
//            console.debug("AdRotate allowRefresh "+allowRefresh);
            timePassed=timePassed+1;
            if(adManager.adsOn==true && adManager.internetOn==true
                    && allowRefresh==true && adManager.appHasFocus==true )
            {
                if(timePassed>= _adInterval)
                {
                    ad.loadAd();
                    timePassed=0;
                }
            }
        }
    }

    function stop() {
        adTimer.stop();
    }

    function start() {
        if(adManager.adsOn==true && adManager.internetOn==true)
        {
            adTimer.start();
        }
    }

    Component.onCompleted: {
        timePassed=_adInterval-15;
        if(adManager.adsOn==true && adManager.internetOn==true)
        {
            ad.loadAd();
        }
        if(autoStart == true) { adTimer.start(); }
    }

}
