
import QtQuick 1.0

Rectangle{
    id:myAdRect
    visible: _ownAdMessage!=""
    color: "transparent"
    property int fontSize: adManager.fontSize*0.95

    Rectangle{
        anchors.fill: parent
        opacity:0.25
        color:"lime"
    }

    Image{
        id:ownAdImage
        anchors{
            top: parent.top
            left: parent.left
            bottom: parent.bottom
            margins: parent.height*0.05
        }
        source:_ownAdImage==""?"":("../"+_ownAdImage)
        smooth: true
        height: parent.height-2*anchors.margins
        fillMode:Image.PreserveAspectFit
    }
    Text{
        anchors{
            left:parent.left
            right: parent.right
            top: parent.top
            bottom: parent.bottom
            leftMargin:ownAdImage.width+15
            rightMargin: 15
        }

        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        text:_ownAdMessage
        wrapMode: Text.Wrap
        font.pixelSize: myAdRect.fontSize
    }
    MouseArea{
        anchors.fill: parent
        onClicked: {
            Qt.openUrlExternally(_ownAdLink);
            console.debug("Launching "+_ownAdLink);
            interstitialWrapper.hide();
            if(interstitialWrapper.quitAfter==true){
                Qt.quit();
            }
        }
    }
}
