Qt.include("fruitslist.js");
var firstTime=true;
var maxRows=6;
var maxColumns=4;
var maxIndex=maxRows*maxColumns;
var board=new Array(maxIndex);
var tileOrder=new Array(maxIndex);
var numberTiles=100;
var borderWidth=10;
var borderSpacing=4;
var blockHeight=0;
var blockWidth=0;
var timebarHeight=50;
var toolbarHeight=100;
var blockSrc="PictureBlock.qml";
var distanceRadius=0;
var component=Qt.createComponent(blockSrc);
var gotBlockCol=0,gotBlockRow=0;
var mx=0.0,my=0.0;
var gotBlockX=0.0;
var gotBlockY=0.0;
var gotBlockOn=false;
var blocksLeft=0;
var buttonSize=0;
var timeStart;
var gameDuration=0;
var moves=0;
var menuOpen=false;
var cronoStarted=false;
var gamePaused=false;
// manage displayed pairs
// number of displayed blocks
var displayedBlocks=0;
// first displayed block
var block1Pos=0;
// last displayed block
var block2Pos=0;
//
function init(){
    if (firstTime){
        firstTime=false;
        blockHeight=Math.floor((screen.height-toolbarHeight-timebarHeight-borderWidth*(maxRows+1))/maxRows);
        blockWidth=Math.floor((screen.width-borderWidth*(maxColumns+1))/maxColumns);
        startNewGame();
    }
}
function orientationChanged()
{
    var i,j,k=0;
    buttonSize=((screen.width<screen.height)?(screen.width/5.75):(screen.height/5.75));
    newGameButton.size=buttonSize;
    helpButton.size=buttonSize;
    aboutButton.size=buttonSize;
    quitButton.size=buttonSize;

    if (screen.height<screen.width){
        //Landscape
        toolbarHeight=newGameButton.width+16;
        blockHeight=Math.floor((screen.height-timebarHeight-(borderWidth+borderSpacing)*(maxColumns+1))/maxColumns);
        blockWidth=Math.floor((screen.width-toolbarHeight-(borderWidth+borderSpacing)*(maxRows+1))/maxRows);
        distanceRadius=Math.sqrt(blockHeight*blockHeight+blockWidth*blockWidth)*0.75;
        //console.log("Landscape");
        for (i=0;i<maxRows;i++)
            for (j=0;j<maxColumns;j++)
                if  (board[index(maxColumns-j-1,i)]!=null)
                {
                    board[index(maxColumns-j-1,i)].x=i*(blockWidth+borderSpacing+borderWidth)+borderWidth+borderSpacing;
                    board[index(maxColumns-j-1,i)].y=j*(blockHeight+borderSpacing+borderWidth)+borderWidth+borderSpacing+timebarHeight;
                    board[index(maxColumns-j-1,i)].width=blockWidth;
                    board[index(maxColumns-j-1,i)].height=blockHeight;
                }
            toolbar.width=newGameButton.width+16;
        toolbar.height=screen.height;
        toolbar.anchors.right=screen.right;
        toolbar.anchors.bottom=undefined;
        highscoreBox.anchors.bottomMargin=20;
        highscoreBox.anchors.rightMargin=20+toolbar.width;
        //   highscoreTxt.anchors.leftMargin=100;
        messageBox.anchors.rightMargin=toolbar.width;
        fog.anchors.rightMargin=toolbar.width;
        fog.anchors.bottomMargin=0;

        toolbarGrid.columns=1;
        toolbarGrid.rows=4;
    }
    else
    {
        //Portrait
        toolbarHeight=newGameButton.height+16;
        blockHeight=Math.floor((screen.height-timebarHeight-toolbarHeight-(borderWidth+borderSpacing)*(maxRows+1))/maxRows);
        blockWidth=Math.floor((screen.width-(borderWidth+borderSpacing)*(maxColumns+1))/maxColumns);
        distanceRadius=Math.sqrt(blockHeight*blockHeight+blockWidth*blockWidth)*0.75;
        //console.log("Portrait");
        for (i=0;i<maxColumns;i++)
            for (j=0;j<maxRows;j++)
                if  (board[index(i,j)]!=null)
                {
                    board[index(i,j)].x=i*(blockWidth+borderSpacing+borderWidth)+borderWidth+borderSpacing;
                    board[index(i,j)].y=j*(blockHeight+borderSpacing+borderWidth)+borderWidth+borderSpacing+timebarHeight;
                    board[index(i,j)].width=blockWidth;
                    board[index(i,j)].height=blockHeight;
                }
            toolbar.width=screen.width;
        toolbar.height=newGameButton.height+16;
        toolbar.anchors.right=undefined;
        toolbar.anchors.bottom=screen.bottom;
        highscoreBox.anchors.bottomMargin=20+toolbar.height;
        highscoreBox.anchors.rightMargin=20;
        messageBox.anchors.rightMargin=0;
        fog.anchors.rightMargin=0;
        fog.anchors.bottomMargin=toolbar.height;

        toolbarGrid.columns=4;
        toolbarGrid.rows=1;

    }
}

function startNewGame(){
    //close opened menus
    hideAboutAction();
    hideHelpAction();
    hideHighscoreAction();
    //free the initial board
    for(var i = 0; i<maxIndex; i++){
        if(board[i] != null)
            board[i].destroy();
    }
    board=new Array(maxIndex);
    genTileOrder();
    blocksLeft=maxIndex;
    timeTxt.text="00:00";
    moves=0;
    movesTxt.text="Moves:0";
    displayedBlocks=0;
    cronoStarted=false;
    stopCrono();
    var j=0;
    for (j=0;j<maxRows;j++)
        for (i=0;i<maxColumns;i++)
        {
            board[index(i,j)]=null;
            createBlock(i,j);
        }

    orientationChanged();
}

//****************** Menus actions *****************
//**************************************************
function displayHelp(){
    if (gamePaused==false){

        helpBox.visible=true;
        hideAboutAction();
        hideHighscoreAction();
        fog.opacity=0.75;
        menuOpen=true;
    }
}
function hideHelpAction(){
    helpBox.visible=false;
    fog.opacity=0;
    menuOpen=false;
}
function displayAbout(){
    if (gamePaused==false){
        aboutBox.show();
        hideHelpAction();
        hideHighscoreAction();
        fog.opacity=0.75;
        menuOpen=true;
    }
}
function hideAboutAction(){
//    aboutBox.visible=false;
    fog.opacity=0;
    menuOpen=false;
}
function displayHighscore(){
    hideHelpAction();
    hideAboutAction();
    highscoreBox.visible=true;
    fog.opacity=0.75;
    menuOpen=true;
}
function hideHighscoreAction(){

    highscoreBox.visible=false;
    fog.opacity=0;
    menuOpen=false;
}
function delayedShowWin(){
    delayWin.start();
}

//****************** End menus actions ****************
//*****************************************************


function index(columns,row){
    return columns+row*maxColumns;
}
function getColumn()
{
    return Math.floor((x-borderWidth)/(blockWidth+borderWidth));
}
function getRow()
{
    return Math.floor((y-borderWidth)/(blockHeight+borderWidth));

}

function createBlock(column,row){
    if (component.status==Component.Ready)
    {
        var dynamicObject = component.createObject(screen,
                                                   {"x": column*(blockWidth+borderWidth+borderSpacing)+borderWidth+borderSpacing,
                                                       "y": row*(blockHeight+borderWidth+borderSpacing)+borderWidth+borderSpacing+timebarHeight,
                                                       "width": blockWidth,
                                                       "height": blockHeight});
        if(dynamicObject == null){
            console.log("error creating block");
            console.log(component.errorString());
            return false;
        }
        dynamicObject.pictureID=tileOrder[index(column,row)];
        dynamicObject.pictureFile='svg//'+fruitName[tileOrder[index(column,row)]]+'.png';
        dynamicObject.fruitName=fruitName[tileOrder[index(column,row)]];
        dynamicObject.col=column;
        dynamicObject.row=row;
        dynamicObject.borderWidth=borderWidth;
        dynamicObject.click.connect(clickedBlock);
        dynamicObject.verifyMatch.connect(verifyMatch);
        board[index(column,row)] = dynamicObject;

    }
    else
    {
        console.log("Error loading block...");
        console.log(component.errorString());
        return false;
    }
}

function getKanjiFile(kanjiID) {
    var s='';
    s=String(kanjiID);
    while (s.length<4) s='0'+s;
    return "gif/k"+s+".gif";
}



function showKeyboard(){
    delayKeyboard.start();
}

function nowShowKeyboard()
{
    nameInputText.openSoftwareInputPanel();
}
//on win action
function showWin(){
    stopCrono();
    nameInputDialog.show("You won! Please enter your name:                 ");
    menuOpen=true;
    fog.opacity=0.75;
    nameInputDialog.text.opacity = 0;
}
function getDistance(idx1,idx2)
{
    return    Math.sqrt((board[idx1].x-board[idx2].x)*
                        (board[idx1].x-board[idx2].x)+
                        (board[idx1].y-board[idx2].y)*
                        (board[idx1].y-board[idx2].y));
}
function addMoves()
{
    moves++;
    movesTxt.text="Moves:"+moves;
}
function updateKanjiInfo()
{
    if (displayedBlocks==0)
    {
        kanji1Txt.text="1:";
        kanji2Txt.text="2:";
    }
    else
        if (displayedBlocks==1)
        {
            kanji1Txt.text="1: "+board[block1Pos].fruitName;
            kanji2Txt.text="2:";
        }
        else
            if (displayedBlocks==2)
            {
                kanji1Txt.text="1: "+board[block1Pos].fruitName;
                kanji2Txt.text="2: "+board[block2Pos].fruitName;
            }
}

function clickedBlock(col,row){
    if (cronoStarted==false){
        cronoStarted=true;
        startCrono();
    }
    if (board[index(col,row)].state=="hidden"){
        addMoves();
        board[index(col,row)].state="hiddenShown";

        if (displayedBlocks==0) {
            block1Pos=index(col,row);
            displayedBlocks++;
        } else
            if (displayedBlocks==1) {
                block2Pos=index(col,row);
                displayedBlocks++;
            } else
                if (displayedBlocks==2) {
                    board[block1Pos].hide();
                    board[block2Pos].hide();
                    displayedBlocks=1;
                    block1Pos=index(col,row);
                }

        updateKanjiInfo();
    }
    else
        if (board[index(col,row)].state=="shown")
        {

            if ((block1Pos==index(col,row))&&(displayedBlocks==2)){
                board[block2Pos].state="shownHidden";
                displayedBlocks--;
                addMoves();
            }else
                if ((block2Pos==index(col,row))&&(displayedBlocks==2)){
                    board[block1Pos].state="shownHidden";
                    block1Pos=block2Pos;
                    displayedBlocks--;
                    addMoves();
                }
            updateKanjiInfo();
        }
}
function verifyMatch(){
    // verify if pairs match
    if (displayedBlocks==2){
        if ((board[block1Pos].pictureID==board[block2Pos].pictureID)&&
                (board[block1Pos].state=="shown")&&
                (board[block2Pos].state=="shown"))
        {
            board[block1Pos].xcenter=board[block1Pos].x+board[block1Pos].width/2;
            board[block1Pos].ycenter=board[block1Pos].y+board[block1Pos].height/2;
            board[block2Pos].xcenter=board[block2Pos].x+board[block2Pos].width/2;
            board[block2Pos].ycenter=board[block2Pos].y+board[block2Pos].height/2;
            board[block1Pos].state='die';
            board[block1Pos]=null;
            board[block2Pos].state='die';
            board[block2Pos]=null;
            blocksLeft-=2;
            displayedBlocks=0;
        }
    }
    if (blocksLeft==0){
        delayedShowWin();
    }
}

//chooses the tiles ids
// shuffles the pairs
function genTileOrder(){
    numberTiles=fruitName.length;
    var tileNN=Math.floor(maxIndex/2);
    var rr=Math.floor(numberTiles/tileNN);
    var rd=0,j=0;
    var nr=0,xx=0,yy=0,xx2=0,yy2=0;
    var aux=0,ntry=0,pairOk,id1=0;
    var mixedN=0;
    var date=new Date();

    for (var i=1;i<=tileNN;i++){
        pairOk=false;
        while (!pairOk){
        rd=Math.floor(Math.random()*numberTiles);
        pairOk=true;
            for (j=1;j<i;j++)
                if (tileOrder[j-1]==rd) pairOk=false;
        }
        tileOrder[i-1]=rd;
    }
    // copy the random pairs
    for (i=1;i<=tileNN;i++)
        tileOrder[i+tileNN-1]=tileOrder[i-1];
    //gen random order
    for (i=1;i<=70;i++)
    {
        xx=Math.floor(Math.random()*maxColumns);
        yy=Math.floor(Math.random()*maxRows);
        xx2=Math.floor(Math.random()*maxColumns);
        yy2=Math.floor(Math.random()*maxRows);
        if (!((xx==xx2)&&(yy==yy2))){
            id1=tileOrder[index(xx,yy)];
            pairOk=true;
            if ((xx2>0)&&(tileOrder[index(xx2-1,yy2)]==id1)) pairOk=false;
            if (pairOk &&(xx2<maxColumns-1)&&(tileOrder[index(xx2+1,yy2)]==id1)) pairOk=false;
            if (pairOk &&(yy2>0)&&(tileOrder[index(xx2,yy2-1)]==id1)) pairOk=false;
            if (pairOk &&(yy2<maxRows-1)&&(tileOrder[index(xx2,yy2+1)]==id1)) pairOk=false;
            if (pairOk)
            {
                id1=tileOrder[index(xx2,yy2)];
                if ((xx>0)&&(tileOrder[index(xx-1,yy)]==id1)) pairOk=false;
                if (pairOk &&(xx<maxColumns-1)&&(tileOrder[index(xx+1,yy)]==id1)) pairOk=false;
                if (pairOk &&(yy>0)&&(tileOrder[index(xx,yy-1)]==id1)) pairOk=false;
                if (pairOk &&(yy<maxRows-1)&&(tileOrder[index(xx,yy+1)]==id1)) pairOk=false;
            }
            if (pairOk)
            {
                aux=tileOrder[index(xx,yy)];
                tileOrder[index(xx,yy)]=tileOrder[index(xx2,yy2)];
                tileOrder[index(xx2,yy2)]=aux;
                mixedN++;
            }
        }
    }


}

//modified paused
function startCrono()
{
    gameTimer.gameLength=0;
    gameTimer.start();
}
function restartCrono()
{
    gameTimer.start();
}

function stopCrono()
{
    gameTimer.stop();
}
function addZero(vv)
{
    if (vv<10) return "0"+vv.toString();
    else return vv.toString();
}

function crono()
{
    if (menuOpen==false) gameTimer.gameLength++;
    var hh=Math.floor(gameTimer.gameLength /3600);
    var mm=Math.floor(gameTimer.gameLength /60)%60;
    var ss=gameTimer.gameLength%60;
    if (hh>0)
        timeTxt.text=hh.toString()+":"+addZero(mm)+":"+addZero(ss);
    else
        timeTxt.text=addZero(mm)+":"+addZero(ss);
    gameDuration=gameTimer.gameLength;
    //    if (gameTimer.gameLength==3) showPause();
    if( adManager.appHasFocus==false && aboutBox.visible==false && helpBox.visible==false){showPause();}
}
function showPause()
{
    stopCrono();
    pauseBox.visible=true;
    gamePaused=true;
    fog.opacity=0.75;

}
function hidePauseAction()
{
    gamePaused=false;
    pauseBox.visible=false;
    restartCrono();
    fog.opacity=0.0;
}

//end modified paused
function saveHighScore(name) {
    //OfflineStorage
    var db = openDatabaseSync("FruitBlocksScores", "1.0", "Local Fruit Blocks High Scores",100);
    var dataStr = "INSERT INTO Scores VALUES(?, ?, ?)";
    var data = [name ,gameDuration,moves];
    db.transaction(
                function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS Scores(name TEXT, time NUMBER,moves NUMBER)');
                    tx.executeSql(dataStr, data);

                    //Only show results for the current grid size
                    var rs = tx.executeSql('SELECT * FROM Scores ORDER BY time ASC LIMIT 5');

                    hModel.clear();
                    for(var i = 0; i < rs.rows.length; i++){
                        hModel.append({name:rs.rows.item(i).name,time:rs.rows.item(i).time,moves:rs.rows.item(i).moves});
                    }
                    displayHighscore();
                }
                );
}

